unit ExcelU;

//*****************************************//
//***  Programa de livre  distribuio. ***//
//***  Solicitamos apenas  no  retirar ***//
//***  ou alterar os direitos autorais. ***//
//***  Estude e melhore  este  projeto. ***//
//*****************************************//
//***            Criado por             ***//
//*** Sigma Deselvolvimento de Software ***//
//***   www.sigmasoftware.hpg.com.br    ***//
//***         www.sgm.rg3.net           ***//
//***          ICQ 142428832            ***//
//*****************************************//
//***  Entenda o  programa  criando  um ***//
//***  arquivo xls primeiro, para ento ***//
//***  depois criar um bd.              ***//
//*****************************************//

interface

uses
  Excel97, ComObj, OleServer, SysUtils, Graphics, Controls, Forms, Buttons, DB, DBTables, ExtCtrls,
  Dialogs, Classes;

type
  TFExcel = class(TForm)
    CPCriar: TSpeedButton;
    CPDialogo: TOpenDialog;
    CPLer: TSpeedButton;
    Panel1: TPanel;
    Panel3: TPanel;
    Tabela: TTable;
    procedure CPCriarClick(Sender: TObject);
    procedure CPLerClick(Sender: TObject);
end;

var
  FExcel: TFExcel;
  Nr_Campos: Integer;

implementation

{$R *.dfm}

procedure TFExcel.CPCriarClick(Sender: TObject);
var
  Planilha, Coluna: Variant;
  Aplicativo: Variant;
  Temp1, Temp2: Integer;
  Temp3: String;
begin
  CPDialogo.Filter:='Arquivos Paradox|*.db';
  if CPDialogo.Execute then
    begin
      Tabela.Close;
      Tabela.DatabaseName:=ExtractFilePath(CPDialogo.FileName);
      Tabela.TableName:=ExtractFileName(CPDialogo.FileName);
      Tabela.Open;
      Temp3:=ChangeFileExt(ExtractFileName(CPDialogo.FileName),'');
      Aplicativo:=CreateOleObject('Excel.Application');
      Aplicativo.Visible:=True;
      Aplicativo.Workbooks.Add(xlWBatWorkSheet);
      Aplicativo.Workbooks[1].WorkSheets[1].Name:=Temp3;
      Planilha:=Aplicativo.Workbooks[1].WorkSheets[Temp3];
      Coluna:=Aplicativo.Workbooks[1].WorkSheets[Temp3].Columns;
      for Temp1:=1 to Tabela.Fields.Count do
        begin
          Planilha.Cells[1,Temp1].Font.Color:=clBlue;
          Planilha.Cells[2,Temp1].Font.Color:=clBlue;
          Planilha.Cells[3,Temp1].Font.Color:=clBlue;
          Planilha.Cells[1,Temp1]:=Tabela.FieldDefs[Temp1-1].Name;
          case Tabela.FieldDefs[Temp1-1].DataType of
            ftAutoInc:  Planilha.Cells[2,Temp1]:='AutoInc';
            ftDate:     Planilha.Cells[2,Temp1]:='Date';
            ftCurrency: Planilha.Cells[2,Temp1]:='Currency';
            ftInteger:  Planilha.Cells[2,Temp1]:='Integer';
            ftFloat:    Planilha.Cells[2,Temp1]:='Float';
            ftString:   Planilha.Cells[2,Temp1]:='String';
          end;
          Planilha.Cells[3,Temp1]:=Tabela.FieldDefs[Temp1-1].Size;
        end;
      for Temp1:=1 to Tabela.RecordCount do
        begin
          Application.ProcessMessages;
          Panel1.Caption:=IntToStr(Tabela.RecordCount-Temp1);
          for Temp2:=0 to Tabela.Fields.Count-1 do Planilha.Cells[Temp1+3,Temp2+1]:=Tabela.Fields[Temp2].AsString;
          Tabela.Next;
        end;
      for Temp1:=1 to Tabela.Fields.Count do Coluna.Columns[Temp1].AutoFit;
      Planilha.SaveAs(ChangeFileExt(CPDialogo.FileName,'.xls'));
      ShowMessage('Planilha salva com sucesso!');
    end;
end;

procedure TFExcel.CPLerClick(Sender: TObject);
var
  Temp1, Temp3, Temp4: Integer;
  Aplicativo: Variant;
  Temp2: Boolean;
begin
  CPDialogo.Filter:='Arquivos do Excel|*.xls';
  if CPDialogo.Execute then
    begin
      Nr_Campos:=0;
      Aplicativo:=CreateOleObject('Excel.Application');
      Aplicativo.Workbooks.Add(CPDialogo.FileName);
      //Linha:=Aplicativo.Rows.Count; Coluna:=Aplicativo.Rows.Count; No funcionou
      for Temp1:=1 to 100 do if UpperCase(Aplicativo.Cells.Item[1,Temp1].Value)<>'' then Inc(Nr_Campos) else Break;
      Application.ProcessMessages;
      ShowMessage('Tabela com '+IntToStr(Nr_Campos)+' campos.');
      Aplicativo.Visible:=True;      
      with Tabela do
        begin
          Close;
          TableType:=ttParadox;
          Tabela.DatabaseName:=ExtractFilePath(CPDialogo.FileName);
          TableName:=ChangeFileExt(CPDialogo.FileName,'');
          if Exists then
            begin
              ShowMessage('Ateno. O arquivo j existe!');
              Abort;
            end;
          with FieldDefs do
            begin
              Clear;
              for Temp1:=1 to Nr_Campos do with AddFieldDef do
                begin
                  Name:=Aplicativo.Cells.Item[1,Temp1].Value;
                  if UpperCase(Aplicativo.Cells.Item[2,Temp1].Value)='AUTOINC'  then DataType:=ftAutoInc;
                  if UpperCase(Aplicativo.Cells.Item[2,Temp1].Value)='CURRENCY' then DataType:=ftCurrency;
                  if UpperCase(Aplicativo.Cells.Item[2,Temp1].Value)='DATE'     then DataType:=ftDate;
                  if UpperCase(Aplicativo.Cells.Item[2,Temp1].Value)='INTEGER'  then DataType:=ftInteger ;
                  if UpperCase(Aplicativo.Cells.Item[2,Temp1].Value)='FLOAT'    then DataType:=ftFloat;
                  if UpperCase(Aplicativo.Cells.Item[2,Temp1].Value)='STRING'   then DataType:=ftString;
                  Size:=Aplicativo.Cells.Item[3,Temp1].Value;
                end;
            end;
          CreateTable;
          ShowMessage('Tabela criada com sucesso!');
        end;
      Temp2:=True;
      Temp3:=0;
      while Temp2 do
        begin
          Application.ProcessMessages;
          Inc(Temp3);
          Panel1.Caption:='Registros: '+IntToStr(Temp3-3);
          if Trim(UpperCase(Aplicativo.Cells.Item[Temp3+1,1].Value))='' then
            begin
              Temp2:=False;
              for Temp1:=1 to Nr_Campos do if Trim(UpperCase(Aplicativo.Cells.Item[Temp3+1,Temp1].Value))<>'' then Temp2:=True;
            end;
        end;
      Tabela.Open;
      Tabela.Insert;
      Tabela.Post;
      for Temp4:=4 to Temp3 do 
        begin
          Application.ProcessMessages;
          Panel1.Caption:='Registros: '+IntToStr(Temp3-Temp4);
          Tabela.Last;
          Tabela.Insert;
          for Temp1:=1 to Nr_Campos do if Tabela.FieldDefs[Temp1-1].DataType<>ftAutoInc then Tabela.Fields[Temp1-1].Value:=Aplicativo.Cells.Item[Temp4,Temp1].Value;
          Tabela.Post;
        end;
      Tabela.Last;
      Tabela.Delete;
      ShowMessage('Dados transferidos com sucesso!');
    end;
end;

end.



